/*
 * memory.h
 * $Id: memory.h,v 1.9 2003/11/11 13:27:21 obi Exp $
 * Christoph Berg <cb@cs.uni-sb.de>
 * Mark Hillebrand <mah@cs.uni-sb.de>
 */

#ifndef MEMORY_H
#define MEMORY_H 1
// VM architecture
#define PX(a) ((a)>>12)
#define BX(a) ((a)&4095)
#define PTE_V(a) (((a)>>11)&1)
#define PTE_P(a) (((a)>>10)&1)
#define PTE_PPX(a) ((a)>>12)
#define PTE_PPX_MASK ((int)0xFFFFF000)

void init_memory(int size);
int load_file(char *fname);
void fill_memory(char *memory, int start, int length, char c);
void count_memory(char *memory, int start, int length);
void poke(char *memory, int pos, int data);
int memop_fetch(unsigned ea,void *data);
int memop_load(int ea,int d,int sign,void *data);
int memop_store(int ea,int d,void *data);
int physicaladdress( int ea );
#endif
