module main(clk,reset,sd_data0,sd_data1,sd_data2,sd_data3,sd_ba,sd_addx,sd_ras_l,sd_cas_l,sd_wr_l,sd_cs_l,sd_dqm0,sd_dqm1,sd_dqm2,sd_dqm3, data_in_capim,data_out_capim,write_capim,BE_capim,access_capim,addr_capim,intr_capim,inta_capim);
   input clk;
   input 	reset;
   inout [15:0] sd_data0;
   inout [15:0] sd_data1;
   inout [15:0] sd_data2;
   inout [15:0] sd_data3;
   output [1:0] sd_ba;
   output [11:0] sd_addx;
   output sd_ras_l;
   output sd_cas_l;
   output sd_wr_l;
   output sd_cs_l;
   output [1:0] sd_dqm0;
   output [1:0] sd_dqm1;
   output [1:0] sd_dqm2;
   output [1:0] sd_dqm3;
	
   input [63:0]  data_in_capim;
   output [63:0] data_out_capim;
   input 	 write_capim;
   input [7:0] 	 BE_capim;
   input	 access_capim;
   input [21:0]	 addr_capim;
   output 	 intr_capim;
   input 	 inta_capim;

//   `define bp_mw        tom1.m0.m4.m0.m1.m0.a_0x;
//   `define bp_mr	tom1.m0.m4.m0.m1.m0.a_1x;
//   `define bp_req	tom1.m0.m4.m0.m1.m0.a_2x;
//   `define bp_burst	tom1.m0.m4.m0.m1.m0.a_3x;
//   `define bp_mwb	tom1.m0.m4.m0.m1.m0.a_4x[7:0];
//   `define bp_adr 	tom1.m0.m4.m0.m1.m0.a_5x[28:0];
//   `define bp_din	tom1.m0.m4.m0.m1.m0.a_6x[31:0];
//   `define bp_reqp	tom1.m0.m4.m0.m1.m0.out_7x;
//   `define bp_brdy	m1.m0.m4.m0.m1.m0.out_8x;
//   `define bp_dout	tom1.m0.m4.m0.m1.m0.out_9x[31:0];

	wire bp_mw;
	wire bp_mr;
	wire bp_req;
	wire bp_burst;
	wire [7:0] bp_mwb;
	wire [28:0] bp_adr;
	wire [63:0] bp_din;
	wire bp_out_reqp;
	wire bp_out_brdy;
	wire [63:0] bp_dout;

   wire [15:0] 	 sd_data0;
   wire [15:0] 	 sd_data1;
   wire [15:0] 	 sd_data2;
   wire [15:0] 	 sd_data3;
   wire [1:0] 	 sd_ba;
   wire [11:0] 	 sd_addx;
   wire 	 sd_ras_l;
   wire 	 sd_cas_l;
   wire 	 sd_wr_l;
   wire 	 sd_cs_l;
   wire [1:0] 	 sd_dqm0;
   wire [1:0] 	 sd_dqm1;
   wire [1:0] 	 sd_dqm2;
   wire [1:0] 	 sd_dqm3;

   // instantiations
   tom_stepx tom1(clk, reset,bp_mw, bp_mr, bp_req, bp_burst,bp_mwb,bp_adr,bp_din, bp_reqp,bp_brdy,bp_dout);
   
   memory_unit mu1(
		   .clk(clk),
		   .reset(reset),
		   
		   // connections to cpu
		   .MAd_cpu({3'b000,bp_adr}),
		   .MDat_in_cpu(bp_din),
		   .MDat_out_cpu(bp_dout),
		   .req_cpu(bp_req),
		   .reqp_cpu(bp_reqp),
		   .BRdy_cpu(bp_brdy),
		   .wr_cpu(bp_mw),
		   .BE_cpu(bp_mwb),
		   
		   // connections to capims
		   .data_in_capim(data_in_capim),
		   .data_out_capim(data_out_capim),
		   .write_capim(write_capim),
		   .BE_capim(BE_capim),
		   .access_capim(access_capim),
		   .addr_capim(addr_capim),
		   .intr_capim(intr_capim),
		   .inta_capim(inta_capim),
		   
		   // connection to sdram chips
		   .sd_data0(sd_data0),
		   .sd_data1(sd_data1),
		   .sd_data2(sd_data2),
		   .sd_data3(sd_data3),
		   .sd_ba(sd_ba),
		   .sd_addx(sd_addx),
		   .sd_ras_l(sd_ras_l),
		   .sd_cas_l(sd_cas_l),
		   .sd_wr_l(sd_wr_l),
		   .sd_cs_l(sd_cs_l),
		   .sd_dqm0(sd_dqm0),
		   .sd_dqm1(sd_dqm1),
		   .sd_dqm2(sd_dqm2),
		   .sd_dqm3(sd_dqm3));

endmodule
